Public Class Widget
  Public Sub New()
    Me.WidgetColor = "red"
    Me.WidgetSize = 12
  End Sub
  Public Sub New(ByVal c As String, ByVal s As Integer)
    Me.WidgetColor = c
    Me.WidgetSize = s
  End Sub


  Dim wColor As String
  Dim wSize As Integer
  Public Property WidgetColor() As String
    Get
      Return wColor
    End Get
    Set(ByVal Value As String)
      Select Case UCase(Value)
        Case "RED", "WHITE", "BLUE"
          wColor = Value
        Case Else
          MessageBox.Show("Bad widget color!")
      End Select
    End Set
  End Property
  Public Property WidgetSize() As Integer
    Get
      Return wSize
    End Get
    Set(ByVal Value As Integer)
      If (Value >= 5 And Value <= 40) Then
        wSize = Value
      Else
        MessageBox.Show("Bad widget size!")
      End If
    End Set
  End Property

  Public Overridable Function DescribeWidget() As String
    Return ("My widget is colored " + wColor)
  End Function
  Public Function CompareWidget() As String
    Dim Diff As Integer
    Diff = wSize - 20
    If Diff > 0 Then
      Return ("My widget is" + Str(Diff) + " units larger than a standard widget.")
    Else
      Return ("My widget is" + Str(Math.Abs(Diff)) + " units smaller than a standard widget.")
    End If
  End Function
  Public Function CompareWidget(ByVal s As Integer) As String
    Dim Diff As Integer
    Diff = wSize - s
    If Diff > 0 Then
      Return ("My widget is" + Str(Diff) + " units larger than your widget.")
    Else
      Return ("My widget is" + Str(Math.Abs(Diff)) + " units smaller than your widget.")
    End If
  End Function

End Class
